﻿using System;

using NATS.Client;

namespace TestCommon
{
    /// <summary>
    /// 메시지 수신시 이벤트 인자
    /// </summary>
    public class MessageReceivedEventArgs : EventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 메시지
        /// </summary>
        private Msg message;

        /// <summary>
        /// 응답 데이터
        /// </summary>
        private byte[] replyData;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주제 - Subject

        /// <summary>
        /// 주제
        /// </summary>
        public string Subject
        {
            get
            {
                return this.message.Subject;
            }
        }

        #endregion
        #region 응답 - Reply

        /// <summary>
        /// 응답
        /// </summary>
        public string Reply
        {
            get
            {
                return this.message.Reply;
            }
        }

        #endregion
        #region 데이터 - Data

        /// <summary>
        /// 데이터
        /// </summary>
        public byte[] Data
        {
            get
            {
                return this.message.Data;
            }
        }

        #endregion

        #region 응답 데이터 - ReplyData

        /// <summary>
        /// 응답 데이터
        /// </summary>
        public byte[] ReplyData
        {
            get
            {
                return this.replyData;
            }
            set
            {
                this.replyData = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MessageReceivedEventArgs(message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        public MessageReceivedEventArgs(Msg message)
        {
            this.message   = message;
            this.replyData = null;
        }

        #endregion
    }
}