﻿using System;
using System.Text;

using TestCommon;

namespace TestReceiver
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Receiver receiver = new Receiver();

            receiver.Initialize("127.0.0.1:4222", "foo", "aaa");

            receiver.MessageReceived += receiver_MessageReceived;

            Console.WriteLine("수신기를 초기화 했습니다.");

            receiver.Start();

            Console.WriteLine("수신기를 시작했습니다.");

            Console.ReadKey();

            receiver.Stop();

            Console.WriteLine("수신기를 중단했습니다.");
        }

        #endregion
        #region 수신기 메시지 수신시 처리하기 - receiver_MessageReceived(sender, e)

        /// <summary>
        /// 수신기 메시지 수신시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private static void receiver_MessageReceived(object sender, MessageReceivedEventArgs e)
        {
            Console.WriteLine("SUBJECT : {0}", e.Subject);
            Console.WriteLine("REPLY   : {0}", e.Reply  );

            string source = Encoding.UTF8.GetString(e.Data);

            Console.WriteLine("메시지 수신 : {0}", source);

            if(!string.IsNullOrEmpty(e.Reply))
            {
                e.ReplyData = Encoding.UTF8.GetBytes("reply : " + DateTime.Now.ToString());
            }
        }

        #endregion
    }
}